package body Demo3_Frame_Package is
   procedure Initialize (V : in out Demo3_Frame) is
      Callptr      : Callback_Button_Ptr;
      Choices : Strings(1..3) := (Rad1'Access,Rad2'Access,Rad3'Access);
   begin
      Initialize(Xv_Frame(V));

      V.Panel_Ptr  := new Xv_Panel(Get_Frame(Xv_Frame(V)),True);

      -- Set some characteristics for the frame window
      Set_Title(Xv_Frame(V),"Hello World #3");
      Set_Pos(Xv_Frame(V),100,100);
      Set_Size(Xv_Frame(V),300,180);
      Set_Max_Size(Xv_Frame(V),600,600);
      Set_Min_Size(Xv_Frame(V),100,100);

      -- Show footer and set left and right footer
      Show_Footer(Xv_Frame(V));
      Set_Left_Footer(Xv_Frame(V),"Left footer text");
      Set_Right_Footer(Xv_Frame(V),"Right footer text");

      -- Quit button --
      V.Quit_Ptr := new Xv_Panel_Button(Get_Panel(V.Panel_Ptr.all));
      Set_Text(V.Quit_Ptr.all,"Quit");
      Callptr := Quit_Func'access;
      Set_Callback(V.Quit_Ptr.all,Callptr);

      -- Create a read-only scrolling list object with three choices
      V.List_Ptr := new Xv_Panel_List(Get_Panel(V.Panel_Ptr.all),True);
      Set_Choices(V.List_Ptr.all,Choices);
      Set_Pos(V.List_Ptr.all,100,10);
      Set_Title(V.List_Ptr.all,"Scroll List");
      -- Select choice two
      Set_Value(V.List_Ptr.all,2,True);
      -- Set displayed rows to five
      Set_Disp_Rows(V.List_Ptr.all,5);

      -- Create a font for the message
      V.Font_Ptr := new Xv_Font(Get_Frame(V),new String'("lucidasans-20"));

      -- Display a message
      V.Mesg_Ptr := new Xv_Panel_Message(Get_Panel(V.Panel_Ptr.all));
      Set_Text(V.Mesg_Ptr.all,"This is a message");
      Set_Pos(V.Mesg_Ptr.all,60,150);
      Set_Font(V.Mesg_Ptr.all,Get_Font(V.Font_Ptr.all));

      -- Ok, here we go...
      Window_Loop(Xv_Frame(V));
   end Initialize;

   procedure Finalize (V : in out Demo3_Frame) is
   begin
      Finalize(Xv_Frame(V));
   end Finalize;

   procedure Quit_Func(Item : Panel_item; Event : Integer) is
   begin 
      raise QUIT_PROGRAM;
   end Quit_Func;
end Demo3_Frame_Package;
